<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctUpdateNomeProdutoOm {
    
    const NOME = "FCT_UPD_NOME_PRODUTO_OM";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param string $idElemento
     * @param string $nmServOrca
     */
    public function executar($idElemento, $nmServOrca) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_IDELEMENTO",  Param::PARAM_INPUT,  $idElemento,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NMSERVORCA",  Param::PARAM_INPUT,  $nmServOrca,   Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
}

?>

