/*
 Tecnisa - Tecnologia em Informtica

 Nome: MSG_REGRAFISCAL

  Descrio:
  Funo para detectar a regra fiscal a ser considerada e, posteriormente, retornar todas as mensagens desta regra fiscal.

 Criao:
 13/06/2012 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'MSG_REGRAFISCAL'
             AND TYPE = 'TF'
             AND U.UID = O.UID
             AND U.NAME = USER)
DROP FUNCTION MSG_REGRAFISCAL
GO

CREATE FUNCTION MSG_REGRAFISCAL
(@P_CDREGRAFISC VARCHAR(10),
 @P_CDEMPRESA   VARCHAR(4)   = NULL,
 @P_IDENTRSAIDOP VARCHAR(1)  = NULL,
 @P_CDTIPOOPER   VARCHAR(2)  = NULL,
 @P_CDINSCESTA   VARCHAR(16) = NULL)
returns @MSG_REGRAFISCAL_TABLE table
(CDREGRAFISC      VARCHAR(10),
 NRMENSREGRAFISC  VARCHAR(10),
 DSMENSREGRAFISC  VARCHAR(150),
 NRVINCFISCREGRA  VARCHAR(10))
AS
BEGIN
   DECLARE @V_NRMENSREGRAFISC       VARCHAR(10);
   DECLARE @V_DSMENSREGRAFISC       VARCHAR(150);
   DECLARE @V_NRVINCFISCREGRA       VARCHAR(10);
   DECLARE C_MENSAGEM CURSOR FOR
      SELECT NRMENSREGRAFISC, DSMENSREGRAFISC, '' NRVINCFISCREGRA
         FROM MENSAGEMREGFISC
        WHERE CDREGRAFISC = @P_CDREGRAFISC
        UNION ALL
      SELECT NRMENSREGRAFISC, DSMENSREGRAFISC, NRVINCFISCREGRA
        FROM MSGVINCULOREGRA
       WHERE CDREGRAFISC = @P_CDREGRAFISC
         AND NRVINCFISCREGRA IN (SELECT NRVINCFISCREGRA
                                   FROM VINCULOFISREGRA
                                  WHERE (VINCULOFISREGRA.CDREGRAFISC  = @P_CDREGRAFISC)
                                    AND (VINCULOFISREGRA.CDEMPRESA    = @P_CDEMPRESA)
                                    AND (VINCULOFISREGRA.IDENTRSAIDOP = @P_IDENTRSAIDOP OR IDENTRSAIDOP IS NULL)
                                    AND (VINCULOFISREGRA.CDTIPOOPER   = @P_CDTIPOOPER   OR CDTIPOOPER   IS NULL)
                                    AND (VINCULOFISREGRA.CDINSCESTA   = @P_CDINSCESTA   OR CDINSCESTA   IS NULL));
   OPEN C_MENSAGEM;
   FETCH NEXT FROM C_MENSAGEM INTO @V_NRMENSREGRAFISC, @V_DSMENSREGRAFISC, @V_NRVINCFISCREGRA;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      IF @V_NRMENSREGRAFISC IS NOT NULL OR @V_DSMENSREGRAFISC IS NOT NULL OR @V_NRVINCFISCREGRA IS NOT NULL BEGIN
         INSERT INTO @MSG_REGRAFISCAL_TABLE
         (CDREGRAFISC, NRMENSREGRAFISC, DSMENSREGRAFISC, NRVINCFISCREGRA)
          VALUES (@P_CDREGRAFISC, @V_NRMENSREGRAFISC, SUBSTRING(@V_DSMENSREGRAFISC, 1, 120), @V_NRVINCFISCREGRA);
      END;
      FETCH NEXT FROM C_MENSAGEM INTO @V_NRMENSREGRAFISC, @V_DSMENSREGRAFISC, @V_NRVINCFISCREGRA;
   END;
   CLOSE C_MENSAGEM;
   DEALLOCATE C_MENSAGEM;
   RETURN;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'MSG_REGRAFISCAL','5.45.000';
GO
